- AnsibleFest
- Products
- Community
- Webinars & Training
- Blog

Documentation

# aws_direct_connect_gateway – Manage AWS Direct Connect Gateway

New in version 2.5.

- Synopsis

- Requirements

- Parameters

- Notes

- Examples

- Return Values

- Status

## Synopsis

- Creates AWS Direct Connect Gateway

- Deletes AWS Direct Connect Gateway

- Attaches Virtual Gateways to Direct Connect Gateway

- Detaches Virtual Gateways to Direct Connect Gateway

## Requirements

The below requirements are needed on the host that executes this module.

- boto

- boto3

- python >= 2.6

## Parameters

Parameter | Choices/Defaults | Comments
--- | --- | ---
amazon_asn - / required |  | amazon side asn
aws_access_key string |  | AWS access key. If not set then the value of the AWS_ACCESS_KEY_ID, AWS_ACCESS_KEY or EC2_ACCESS_KEY environment variable is used. aliases: ec2_access_key, access_key
aws_secret_key string |  | AWS secret key. If not set then the value of the AWS_SECRET_ACCESS_KEY, AWS_SECRET_KEY, or EC2_SECRET_KEY environment variable is used. aliases: ec2_secret_key, secret_key
debug_botocore_endpoint_logs boolean added in 2.8 | Choices: no ← yes | Use a botocore.endpoint logger to parse the unique (rather than total) "resource:action" API calls made during a task, outputing the set to the resource_actions key in the task results. Use the aws_resource_action callback to output to total list made during a playbook. The ANSIBLE_DEBUG_BOTOCORE_LOGS environment variable may also be used.
direct_connect_gateway_id - |  | id of an existing direct connect gateway
ec2_url string |  | Url to use to connect to EC2 or your Eucalyptus cloud (by default the module will use EC2 endpoints). Ignored for modules where region is required. Must be specified for all other modules if region is not used. If not set then the value of the EC2_URL environment variable, if any, is used.
name - |  | name of the dxgw to be created or deleted
profile string |  | Uses a boto profile. Only works with boto >= 2.24.0.
region string |  | The AWS region to use. If not specified then the value of the AWS_REGION or EC2_REGION environment variable, if any, is used. See http://docs.aws.amazon.com/general/latest/gr/rande.html#ec2_region aliases: aws_region, ec2_region
security_token string |  | AWS STS security token. If not set then the value of the AWS_SECURITY_TOKEN or EC2_SECURITY_TOKEN environment variable is used. aliases: access_token
state - | Choices: present ← absent | present to ensure resource is created. absent to remove resource
validate_certs boolean | Choices: no yes ← | When set to "no", SSL certificates will not be validated for boto versions >= 2.6.0.
virtual_gateway_id - |  | vpn gateway id of an existing virtual gateway

## Notes

Note

- If parameters are not set within the module, the following environment variables can be used in decreasing order of precedence `AWS_URL` or `EC2_URL`, `AWS_ACCESS_KEY_ID` or `AWS_ACCESS_KEY` or `EC2_ACCESS_KEY`, `AWS_SECRET_ACCESS_KEY` or `AWS_SECRET_KEY` or `EC2_SECRET_KEY`, `AWS_SECURITY_TOKEN` or `EC2_SECURITY_TOKEN`, `AWS_REGION` or `EC2_REGION`

- Ansible uses the boto configuration file (typically ~/.boto) if no credentials are provided. See https://boto.readthedocs.io/en/latest/boto_config_tut.html

- `AWS_REGION` or `EC2_REGION` can be typically be used to specify the AWS region, when required, but this can also be configured in the boto config file

## Examples

    - name: Create a new direct connect gateway attached to virtual private gateway
      dxgw:
        state: present
        name: my-dx-gateway
        amazon_asn: 7224
        virtual_gateway_id: vpg-12345
      register: created_dxgw

    - name: Create a new unattached dxgw
      dxgw:
        state: present
        name: my-dx-gateway
        amazon_asn: 7224
      register: created_dxgw

## Return Values

Common return values are documented here, the following are the fields unique to this module:

Key | Returned | Description
--- | --- | ---
result complex | state=present | The attributes of the Direct Connect Gateway
| amazon_side_asn - |  | ASN on the amazon side.
| direct_connect_gateway_id - |  | The ID of the direct connect gateway.
| direct_connect_gateway_name - |  | The name of the direct connect gateway.
| direct_connect_gateway_state - |  | The state of the direct connect gateway.
| owner_account - |  | The AWS account ID of the owner of the direct connect gateway.

## Status

- This module is not guaranteed to have a backwards compatible interface. [preview]

- This module is maintained by the Ansible Community. [community]

### Authors

- Gobin Sougrakpam (@gobins)

Hint

If you notice any issues in this documentation, you can edit this document to improve it.